#!/usr/bin/python3
# -*- coding: utf-8 -*-
#import evdev
from evdev import InputDevice, categorize, ecodes
import sys

# print ('Nombre d\'arguments:', len(sys.argv), 'arguments.')
# print ('Llista d\'arguments:', str(sys.argv))

if len(sys.argv) == 2:
	# print("Segon argument: %s" % sys.argv[1])
	dispositiu = '/dev/input/event' + sys.argv[1]
else:
	dispositiu = '/dev/input/event18' # Canvieu 18 pel vostre número d'esdeveniment

#cree un objet gamepad | creates object gamepad
# gamepad = InputDevice('/dev/input/event18')
gamepad = InputDevice(dispositiu)

#affiche la liste des device connectes | prints out device info at start
print(gamepad)

aBtn = 289
bBtn = 290
xBtn = 288
yBtn = 291
lBtn = 292
rBtn = 293
selBtn = 296
staBtn = 297

#affiche les codes interceptes |  display codes
for event in gamepad.read_loop():
    #Boutons | buttons 
    if event.type == ecodes.EV_KEY:
        #print(event)
        if event.value == 1:
            if event.code == xBtn:
                print("joyX")
            elif event.code == bBtn:
                print("joyB")
            elif event.code == aBtn:
                print("joyA")
            elif event.code == yBtn:
                print("joyY")
            elif event.code == lBtn:
                print("joyL")
            elif event.code == rBtn:
                print("joyR")
            elif event.code == selBtn:
                print("joySelect")
            elif event.code == staBtn:
                print("joyStart")
        elif event.value == 0:
          print("joyDeixatAnar")

    #Gamepad analogique | Analog gamepad
    elif event.type == ecodes.EV_ABS:
        absevent = categorize(event)
        #print ecodes.bytype[absevent.event.type][absevent.event.code], absevent.event.value
        if ecodes.bytype[absevent.event.type][absevent.event.code] == "ABS_X":
             if absevent.event.value == 0:
                print("joyEsquerra")
             elif absevent.event.value == 255:
                print("joyDreta")
             elif absevent.event.value == 127:
                print("joyCentre")
        elif ecodes.bytype[absevent.event.type][absevent.event.code] == "ABS_Y":
             if absevent.event.value == 0:
                print("joyAmunt")
             elif absevent.event.value == 255:
                print("joyAvall")
             elif absevent.event.value == 127:
                print("joyCentre")
