#!/usr/bin/python3
# -*- coding: utf-8 -*-
#import evdev
from evdev import InputDevice, categorize, ecodes
import sys
import socket

HOST = 'localhost'
PORT = 42001

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.connect((HOST, PORT))

def sendCMD(cmd):
    sock.send(len(cmd).to_bytes(4, 'big'))
    sock.send(bytes(cmd, 'UTF-8'))
    
 
# print ('Nombre d\'arguments:', len(sys.argv), 'arguments.')
# print ('Llista d\'arguments:', str(sys.argv))

if len(sys.argv) == 2:
	# print("Segon argument: %s" % sys.argv[1])
	dispositiu = '/dev/input/event' + sys.argv[1]
else:
	dispositiu = '/dev/input/event18' # Canvieu 18 pel vostre número d'esdeveniment

#cree un objet gamepad | creates object gamepad
# gamepad = InputDevice('/dev/input/event18')
gamepad = InputDevice(dispositiu)

#affiche la liste des device connectes | prints out device info at start
print(gamepad)

aBtn = 289
bBtn = 290
xBtn = 288
yBtn = 291
lBtn = 292
rBtn = 293
selBtn = 296
staBtn = 297

ordre = ""
#affiche les codes interceptes |  display codes
for event in gamepad.read_loop():
	#Boutons | buttons 
	if event.type == ecodes.EV_KEY:
		#print(event)
		if event.value == 1:
			if event.code == xBtn:
				ordre = "joyX"
				# print("joyX")
			elif event.code == bBtn:
				ordre = "joyB"
                # print("joyB")
			elif event.code == aBtn:
				ordre = "joyA"
                # print("joyA")
			elif event.code == yBtn:
				ordre = "joyY"
                # print("joyY")
			elif event.code == lBtn:
				ordre = "joyL"
                # print("joyL")
			elif event.code == rBtn:
				ordre = "joyR"
                # print("joyR")
			elif event.code == selBtn:
				ordre = "joySelect"
                # print("joySelect")
			elif event.code == staBtn:
				ordre = "joyStart"
                # print("joyStart")
		elif event.value == 0:
			ordre = "joyDeixatAnar"
			# print("joyDeixatAnar")
		print(ordre)
		sendCMD('broadcast "%s"' % ordre)

    #Gamepad analogique | Analog gamepad
	elif event.type == ecodes.EV_ABS:
		absevent = categorize(event)
        #print ecodes.bytype[absevent.event.type][absevent.event.code], absevent.event.value
		if ecodes.bytype[absevent.event.type][absevent.event.code] == "ABS_X":
			if absevent.event.value == 0:
				ordre = "joyEsquerra"
				 # print("joyEsquerra")
			elif absevent.event.value == 255:
				 ordre = "joyDreta"
				 # print("joyDreta")
			elif absevent.event.value == 127:
				 ordre = "joyCentre"
				 # print("joyCentre")
		elif ecodes.bytype[absevent.event.type][absevent.event.code] == "ABS_Y":
			if absevent.event.value == 0:
				ordre = "joyAmunt"
				# print("joyAmunt")
			elif absevent.event.value == 255:
				ordre = "joyAvall"
				# print("joyAvall")
			elif absevent.event.value == 127:
				ordre = "joyCentre"
				# print("joyCentre")
		print(ordre)
		sendCMD('broadcast "%s"' % ordre)
